#ifndef TCC_OPTION_H
# define TCC_OPTION_H 1

# include <stdint.h>

# define TCC_OPTION_HAS_ARG 0x0001
# define TCC_OPTION_NOSEP   0x0002 /** cannot have space before option and arg */

# define TCC_OPT_HELP       'h'
# define TCC_OPT_HELP_MORE  'm'
# define TCC_OPT_ARCHIVE    'a'
# define TCC_OPT_VERSION    'V'
# define TCC_OPT_PRINT_DIRS 'P'

typedef struct TCCOption {
	const char *name;
	uint16_t index;
	uint16_t flags;
} TCCOption;

typedef struct TCCState TCCState;

int tcc_parse_args(TCCState *s, int *argc, char ***argv, int optind);
void tcc_add_options(TCCOption *opts);

#endif /* TCC_OPTION_H */